diff -U 3 -H -d -r -N -- src/Fl_Choice.cxx src/Fl_Choice.cxx
--- src/Fl_Choice.cxx	2011-07-19 10:49:30.000000000 +0600
+++ src/Fl_Choice.cxx	2013-12-07 21:04:57.000000000 +0600
@@ -20,22 +20,26 @@
 #include <FL/Fl_Choice.H>
 #include <FL/fl_draw.H>
 #include "flstring.h"
+#include "fl_oxy.h"
 
 // Emulates the Forms choice widget.  This is almost exactly the same
 // as an Fl_Menu_Button.  The only difference is the appearance of the
 // button: it draws the text of the current pick and a down-arrow.
 
 void Fl_Choice::draw() {
+  bool flag_oxy = (Fl::scheme() && !strcmp(Fl::scheme(), "oxy"));
   int dx = Fl::box_dx(FL_DOWN_BOX);
   int dy = Fl::box_dy(FL_DOWN_BOX);
   int H = h() - 2 * dy;
-  int W = (H > 20) ? 20 : H;
+  int W = (H > 20) ? 20 : H; if (flag_oxy) { W = 17; }
   int X = x() + w() - W - dx;
   int Y = y() + dy;
   int w1 = (W - 4) / 3; if (w1 < 1) w1 = 1;
   int x1 = X + (W - 2 * w1 - 1) / 2;
   int y1 = Y + (H - w1 - 1) / 2;
 
+  fl_push_clip(x(), y(), w(), h());
+  
   if (Fl::scheme()) {
     draw_box(FL_UP_BOX, color());
 
@@ -46,16 +50,38 @@
       fl_polygon(x1, y1 + 1, x1 + w1, y1 - w1 + 1, x1 + 2 * w1, y1 + 1);
     } else {
       // Show smaller up/down arrows with a divider...
-      x1 = x() + w() - 13 - dx;
-      y1 = y() + h() / 2;
-      fl_polygon(x1, y1 - 2, x1 + 3, y1 - 5, x1 + 6, y1 - 2);
-      fl_polygon(x1, y1 + 2, x1 + 3, y1 + 5, x1 + 6, y1 + 2);
 
-      fl_color(fl_darker(color()));
-      fl_yxline(x1 - 7, y1 - 8, y1 + 8);
+      Fl_Color hlcol = 0x0;
+      
+      if (flag_oxy) { // if was seted the theme `oxy'
+       x1 = x() + w() - dx/2 - W/2 - 5;
+       y1 = y()-1 + h()/2 - 1;
+       
+       // draw down arrow
+       oxy_arrow(x1, y1, FL_ALIGN_BOTTOM, active_r(), color(), FL_BLACK);
+       // draw the divider
+       hlcol = fl_color_average(color(), FL_BLACK, 0.88);
+       fl_color(active_r()?hlcol:fl_inactive(hlcol));
+       fl_yxline(X, y()+dy, y()+h()-dx-2);
+       hlcol = fl_lighter(color());
+       fl_color(active_r()?hlcol:fl_inactive(hlcol));
+       fl_yxline(X+1, y()+dy, y()+h()-dx-2);
+       
+      } else {
+       x1 = x() + w() - 13 - dx;
+       y1 = y() + h() / 2; if (flag_oxy) { y1 -= 1; }
+       fl_polygon(x1, y1 - 2, x1 + 3, y1 - 5, x1 + 6, y1 - 2);
+       fl_polygon(x1, y1 + 2, x1 + 3, y1 + 5, x1 + 6, y1 + 2);
+       
+       hlcol = fl_darker(color());
+       fl_color(active_r()?hlcol:fl_inactive(hlcol));
+       fl_yxline(x1 - 7, y1 - 8, y1 + 8);
+       
+       hlcol = fl_lighter(color());
+       fl_color(active_r()?hlcol:fl_inactive(hlcol));
+       fl_yxline(x1 - 6, y1 - 8, y1 + 8);
+      }
 
-      fl_color(fl_lighter(color()));
-      fl_yxline(x1 - 6, y1 - 8, y1 + 8);
     }
   } else {
     if (fl_contrast(textcolor(), FL_BACKGROUND2_COLOR) == textcolor()) {
@@ -78,7 +104,8 @@
     // ERCO
     int xx = x() + dx, yy = y() + dy + 1, ww = w() - W, hh = H - 2;
 
-    fl_push_clip(xx, yy, ww, hh);
+    if(flag_oxy) fl_push_clip(xx, yy-1, ww-dx-2, h()-dy-dy/2-1);
+    else fl_push_clip(xx, yy, ww, hh);
 
     if ( Fl::scheme()) {
       Fl_Label l;
@@ -91,9 +118,9 @@
       l.color= m.labelcolor_ ? m.labelcolor_ : textcolor();
       if (!m.active()) l.color = fl_inactive((Fl_Color)l.color);
       fl_draw_shortcut = 2; // hack value to make '&' disappear
-      l.draw(xx+3, yy, ww>6 ? ww-6 : 0, hh, FL_ALIGN_LEFT);
+      if(flag_oxy) l.draw(xx+2, yy, ww-dx/2-3, hh, FL_ALIGN_LEFT);
+      else l.draw(xx+3, yy, ww>6 ? ww-6 : 0, hh, FL_ALIGN_LEFT);
       fl_draw_shortcut = 0;
-      if ( Fl::focus() == this ) draw_focus(box(), xx, yy, ww, hh);
     }
     else {
       fl_draw_shortcut = 2; // hack value to make '&' disappear
@@ -102,6 +129,10 @@
     }
 
     fl_pop_clip();
+    fl_pop_clip();
+    
+    if ( Fl::focus() == this ) draw_focus(box(), xx, yy-1, flag_oxy?ww-dx/2:ww, flag_oxy?h()-dy-dy:hh);
+    
   }
 
   draw_label();
@@ -155,11 +186,12 @@
 int Fl_Choice::handle(int e) {
   if (!menu() || !menu()->text) return 0;
   const Fl_Menu_Item* v;
+  bool flag_oxy = (Fl::scheme() && !strcmp(Fl::scheme(), "oxy"));
   switch (e) {
   case FL_ENTER:
   case FL_LEAVE:
-    return 1;
-
+   return 1;
+  
   case FL_KEYBOARD:
     if (Fl::event_key() != ' ' ||
         (Fl::event_state() & (FL_SHIFT | FL_CTRL | FL_ALT | FL_META))) return 0;
@@ -168,24 +200,24 @@
   J1:
     if (Fl::scheme()
 	|| fl_contrast(textcolor(), FL_BACKGROUND2_COLOR) != textcolor()) {
-      v = menu()->pulldown(x(), y(), w(), h(), mvalue(), this);
+      v = menu()->pulldown(x(), y(), w(), h(), flag_oxy?0:mvalue(), this);
     } else {
       // In order to preserve the old look-n-feel of "white" menus,
       // temporarily override the color() of this widget...
       Fl_Color c = color();
       color(FL_BACKGROUND2_COLOR);
-      v = menu()->pulldown(x(), y(), w(), h(), mvalue(), this);
+      v = menu()->pulldown(x(), y(), w(), h(), flag_oxy?0:mvalue(), this);
       color(c);
     }
     if (!v || v->submenu()) return 1;
-    if (v != mvalue()) redraw();
+    /*if (v != mvalue())*/ redraw(); // NOTE: for see the focus (kdiman)
     picked(v);
     return 1;
   case FL_SHORTCUT:
     if (Fl_Widget::test_shortcut()) goto J1;
     v = menu()->test_shortcut();
     if (!v) return 0;
-    if (v != mvalue()) redraw();
+    /*if (v != mvalue())*/ redraw(); // NOTE: for see the focus (kdiman)
     picked(v);
     return 1;
   case FL_FOCUS:
diff -U 3 -H -d -r -N -- src/Fl_Clock_Input.cxx src/Fl_Clock_Input.cxx
--- src/Fl_Clock_Input.cxx	1970-01-01 05:00:00.000000000 +0500
+++ src/Fl_Clock_Input.cxx	2013-12-21 09:51:00.342448120 +0600
@@ -0,0 +1,384 @@
+// Fl_Clock_Input (written by "Dmitrij K" <kdiman at live dot ru>) for the Fast Light Tool Kit (FLTK).
+//  license:   http://www.fltk.org/COPYING.php
+
+#ifndef Fl_Clock_Input_cxx
+#define Fl_Clock_Input_cxx
+
+#include <FL/Fl.H>
+#include <FL/Fl_Clock_Input.H>
+#include <stdlib.h>
+#include <string.h>
+#include <FL/names.h>
+
+// g++ -I/usr/local/include/FL -I../ -c Fl_Clock_Input.cxx
+
+Fl_Clock_Input::Fl_Clock_Input(int X,int Y,int W,int H,const char*L)
+: Fl_Input(X,Y,W,H,L),
+_lp(0){
+ set_values(12, 30);
+}
+
+
+
+int Fl_Clock_Input::handle(int e){
+ //printf("Fl_Clock_Input: %s\n", fl_eventnames[e]);
+  if(!active_r()/* || readonly()*/){ Fl_Input::handle(e); }
+  switch(e){
+   
+   case FL_UNFOCUS: {
+    _lp = position();
+    check_value();
+    break;
+   }
+   
+   case FL_PUSH: {
+    
+    int r = Fl_Input::handle(e);
+    _lp = position();
+    check_value();
+    if(Fl::focus() != this){ take_focus(); }
+    return r;
+   }
+   
+   
+   case FL_PASTE:
+   case FL_KEYBOARD: {
+    int k, p, m, letext, litext, r, sinv = 0;
+    k = Fl::event_key();
+    if(k == FL_Tab && Fl_Input::tab_nav()){ return Fl_Input::handle(e); }
+    if(k == FL_Enter || k == FL_KP_Enter){ return Fl_Input::handle(e); }
+    if(k == FL_Home || k == FL_End){ return Fl_Input::handle(e); }
+    const char *etext = Fl::event_text();
+    const char *itext = Fl_Input::value();
+    const char *d = NULL; int id = 0, sd = 0;
+    char cstr[8]; memset(cstr, 0, 8);
+    char hv[8]; memset(hv, 0, 8); // hours value in the cstring mode
+    char mv[8]; memset(mv, 0, 8); // minutes value in the cstring mode
+    int lhv = 0, lmv = 0;
+    p = position();
+    m = mark();
+    if(p > m){ sinv = 1; int tp = p; p=m; m=tp; }
+    int cs = m-p; // number of selection symbols
+    if(itext && (d = strchr(itext, ':'))){ id = d-itext; } // id is index of divider `:'
+    else { return 1; }
+    if(cs > 0){ for(int _i = p, j = 0; _i < m; _i++, j++){ cstr[j] = itext[_i]; } }
+    letext = strlen(etext); litext = strlen(itext);
+    sd = (strchr(cstr, ':') != NULL);
+    for(int _i = 0; _i < id; _i++){ hv[_i] = itext[_i]; }
+    for(int _i = id+1, j = 0; _i < litext; _i++, j++){ mv[j] = itext[_i]; }
+    lhv = strlen(hv); lmv = strlen(mv);
+    
+    if(e == FL_PASTE || (Fl::event_ctrl() && k == 'v')){ // INSERT/PASTE
+     Fl_Input o(0,0,0,0,0); o.type(FL_INT_INPUT);
+     Fl::paste(o, 1);
+     const char *ov = o.value();
+     int lov = strlen(ov);
+     if(cs > 0 && strchr(cstr, ':')){ return 1; }
+     if(lov <= 0 || lov > 2){ return 1; }
+     for(int _i = 0; _i < lov; _i++){ if(ov[_i] < '0' || ov[_i] > '9'){ return 1; } }
+     
+     if(p <= id && m <= id){ // hours
+      if((r = lhv-cs+lov) > 2){ return 1; }
+      // check new value for hours
+      for(int _i = p, _io = 0; _i < r; _i++, _io++){
+       if(p == m){ hv[_i+1] = hv[_i]; }
+       if(p==0){ if(_i+1 < r){ hv[_i] = ov[_io]; } }
+       else { hv[_i] = ov[_io]; }
+      }
+      hv[r] = '\0';
+      if(strlen(hv) > 2){ return 1; }
+      if(strtol(hv, NULL, 10) > 23){ return 1; }
+     }
+     else { // minutes
+      if((r = lmv-cs+lov) > 2){ return 1; }
+      int _I = p-lhv-1;
+      // check new value for minutes
+      for(int _i = _I, _io = 0; _i < r; _i++, _io++){
+       if(p == m){ mv[_i+1] = mv[_i]; }
+       if(_I == 0){ if(_i+1 < r){ mv[_i] = ov[_io]; } }
+       else { mv[_i] = ov[_io]; }
+      }
+      mv[r] = '\0';
+      if(strlen(mv) > 2){ return 1; }
+      if(strtol(mv, NULL, 10) > 59){ return 1; }
+     }
+     replace(p, m, ov, lov);
+     return 1;
+    }
+    
+    else if(Fl::event_ctrl() && k == 'c'){ // COPY
+     if(cs > 0){ Fl::copy(cstr, (int) strlen(cstr), 1); }
+     return 1;
+    }
+    
+    else if(Fl::event_ctrl() && k == 'x'){ // CUT
+     if(cs > 0){
+      if(strchr(cstr, ':')){ return 1; }
+      Fl::copy(cstr, (int) strlen(cstr), 1);
+      replace(p, m, 0);
+     }
+     return 1;
+    }
+    
+    
+    if(k == FL_BackSpace){
+     if(sd || (p == m && id == (p-1))){ return 1; } // don't touch divider's `:'
+     break;
+    }
+    else if(k == FL_Delete){
+     if(sd || (p == m && id == p)){ return 1; } // don't touch divider's `:'
+     break;
+    }
+    
+    if(k == FL_Left){
+     if(sd || (id == (p-1) && !sinv)){
+      if(Fl::focus() != this){ take_focus(); redraw(); }
+      r = Fl_Input::handle(e);
+      check_value();
+      return r;
+     }
+     break;
+    }
+    else if(k == FL_Right){
+     if(sd || (id == p && !sinv) || (id == m && sinv)){
+      if(Fl::focus() != this){ take_focus(); redraw(); }
+      r = Fl_Input::handle(e);
+      check_value();
+      return r;
+     }
+     break;
+    }
+    
+    if(k == FL_Up){ check_value(); _lp = p; incr(); return 1; }
+    else if(k == FL_Down){ check_value(); _lp = p; decr(); return 1; }
+    
+    if(sd){ return 1; }
+    for(int _i = 0; _i < letext; _i++){ if(etext[_i] < '0' || etext[_i] > '9'){ return 1; } }
+    
+    /// printf("line: %d\n", __LINE__);
+    
+    if(p <= id && m <= id){ // hours
+     if((r = lhv-cs+letext) > 2){ return 1; }
+     for(int _i = p, _io = 0; _i < r; _i++, _io++){
+      if(p == m){ hv[_i+1] = hv[_i]; }
+      if(p==0){ if(_i+1 < r){ hv[_i] = etext[_io]; } }
+      else { hv[_i] = etext[_io]; }
+     }
+     hv[r] = '\0';
+     if(strlen(hv) > 2){ return 1; }
+     if(strtol(hv, NULL, 10) > 23){ return 1; }
+    }
+    
+    else { // minutes
+     if((r = lmv-cs+letext) > 2){ return 1; }
+     int _I = p-lhv-1;
+     for(int _i = _I, _io = 0; _i < r; _i++, _io++){
+      if(p == m){ mv[_i+1] = mv[_i]; }
+      if(_I==0){ if(_i+1 < r){ mv[_i] = etext[_io]; } }
+      else { mv[_i] = etext[_io]; }
+     }
+     mv[r] = '\0';
+     if(strlen(mv) > 2){ return 1; }
+     if(strtol(mv, NULL, 10) > 59){ return 1; }
+    }
+    
+    if(letext > 0){ replace(p, m, etext, letext); }
+    return 1;
+    break;
+   }
+   
+   default: break;
+  }
+  return Fl_Input::handle(e);
+ }
+
+
+
+
+
+void Fl_Clock_Input::check_value(){
+  const char *itext = Fl_Input::value();
+  int litext = strlen(itext);
+  if(litext != 5){
+   char hv[8]; memset(hv, 0, 8);
+   char mv[8]; memset(mv, 0, 8);
+   const char *d = strchr(itext, ':');
+   int lhv = 0, lmv = 0, v = 0, isd = (d != NULL);
+   int p = position();
+   int m = mark();
+   int ph = 0, id = 0, np = p;
+   
+   if(isd){
+    np = d-itext;
+    memcpy(hv, itext, np);
+    lhv = strlen(hv);
+    lmv = np+1;
+    memcpy(mv, itext+lmv, litext-lmv);
+    lmv = strlen(mv);
+   }
+   np = p;
+   
+   if(lhv != 2 || lmv != 2 || !isd){
+    if(!isd){
+     Fl_Input::value("00:00");
+     return ;
+    }
+    ph = (p<=m)?p:m;
+    id = (d-itext); // index of divider
+    ph = (ph <= id); // is position on place of hours ?
+    v = strtol(hv, NULL, 10);
+    if(lhv != 2 || v < 0 || v > 23){
+     np += (2-lhv);
+     if(v < 0){ v = 0; }
+     else if(v > 23){ v = 23; }
+     _hours = v;
+     sprintf(hv, "%02d", v);
+    }
+    
+    strcat(hv, ":");
+    v = strtol(mv, NULL, 10);
+    
+    if(lmv != 2 || v < 0 || v > 59){
+     if(!ph){ np -= (2-lmv); }
+     if(v < 0){ v = 0; }
+     else if(v > 59){ v = 59; }
+     _minutes = v;
+     sprintf(hv+strlen(hv), "%02d", v);
+    } else { strcat(hv, mv); }
+    Fl_Input::value(hv);
+    Fl_Input::position(np);
+   }
+  }
+ }
+
+ 
+ 
+ 
+
+ void Fl_Clock_Input::incr(){
+  const char *itext = Fl_Input::value();
+  char hv[8]; memset(hv, 0, 8);
+  char mv[8]; memset(mv, 0, 8);
+  char nv[8]; memset(nv, 0, 8);
+  int v_hv, v_mv;
+  
+  memcpy(hv, itext, 2);
+  memcpy(mv, itext+3, 2);
+  v_hv = strtol(hv, NULL, 10);
+  v_mv = strtol(mv, NULL, 10);
+  
+  if(_lp < 3){ // hours
+   v_hv++;
+   if(v_hv > 23){ v_hv = 0; }
+   sprintf(nv, "%02d", v_hv);
+   memcpy(hv, nv, 2);
+  }
+  
+  else { // minutes
+   v_mv++;
+   if(v_mv > 59){
+    v_hv++;
+    if(v_hv > 23){ v_hv = 0; }
+    sprintf(nv, "%02d", v_hv);
+    memcpy(hv, nv, 2);
+    v_mv = 0;
+   }
+   sprintf(nv, "%02d", v_mv);
+   memcpy(mv, nv, 2);
+  }
+  _hours = v_hv;
+  _minutes = v_mv;
+  sprintf(hv+2, ":%s", mv);
+  Fl_Input::value(hv);
+  Fl_Input::position(_lp);
+ }
+ 
+ 
+ 
+ 
+ void Fl_Clock_Input::decr(){
+  
+  const char *itext = Fl_Input::value();
+  char hv[8]; memset(hv, 0, 8);
+  char mv[8]; memset(mv, 0, 8);
+  char nv[8]; memset(nv, 0, 8);
+  int v_hv, v_mv;
+  
+  memcpy(hv, itext, 2);
+  memcpy(mv, itext+3, 2);
+  v_hv = strtol(hv, NULL, 10);
+  v_mv = strtol(mv, NULL, 10);
+  
+  if(_lp < 3){ // hours
+   v_hv--;
+   if(v_hv < 0){ v_hv = 23; }
+   sprintf(nv, "%02d", v_hv);
+   memcpy(hv, nv, 2);
+  }
+  
+  else { // minutes
+   v_mv--;
+   if(v_mv < 0){
+    v_hv--;
+    if(v_hv < 0){ v_hv = 23; }
+    sprintf(nv, "%02d", v_hv);
+    memcpy(hv, nv, 2);
+    v_mv = 59;
+   }
+   sprintf(nv, "%02d", v_mv);
+   memcpy(mv, nv, 2);
+  }
+  _hours = v_hv;
+  _minutes = v_mv;
+  sprintf(hv+2, ":%s", mv);
+  Fl_Input::value(hv);
+  Fl_Input::position(_lp);
+  
+ }
+ 
+ 
+ 
+ 
+ void Fl_Clock_Input::get_values(int &hour, int &minutes){
+  hour = _hours;
+  minutes = _minutes;
+ }
+ 
+ 
+ void Fl_Clock_Input::set_values(int hour, int minute, int pos){
+  if(hour < 0 || hour > 23){ return; }
+  if(minute < 0 || minute > 59){ return; }
+  _hours = hour;
+  _minutes = minute;
+  update(pos);
+ }
+ 
+ 
+ void Fl_Clock_Input::hours(int hour){
+  if(hour >= 0 && hour <=23){
+   _hours = hour;
+   update();
+  }
+ }
+ 
+ 
+ void Fl_Clock_Input::minutes(int minute){
+  if(minute >= 0 && minute <= 59){
+   _minutes = minute;
+   update();
+  }
+ }
+ 
+ 
+ void Fl_Clock_Input::update(int pos){
+  char str[8];
+  snprintf(str, 8, "%02d:%02d", _hours, _minutes);
+  Fl_Input::value(str);
+  if(pos >= 0){ position(pos); }
+  else { position(_lp); }
+  redraw();
+ }
+ 
+ 
+ 
+#endif
diff -U 3 -H -d -r -N -- src/Fl_Clock_Spinner.cxx src/Fl_Clock_Spinner.cxx
--- src/Fl_Clock_Spinner.cxx	1970-01-01 05:00:00.000000000 +0500
+++ src/Fl_Clock_Spinner.cxx	2013-12-21 09:51:00.342448120 +0600
@@ -0,0 +1,122 @@
+// Fl_Clock_Spinner (written by "Dmitrij K" <kdiman at live dot ru>) for the Fast Light Tool Kit (FLTK).
+//  license:   http://www.fltk.org/COPYING.php
+
+#ifndef Fl_Clock_Spinner_cxx
+#define Fl_Clock_Spinner_cxx
+
+#include <FL/Fl_Clock_Spinner.H>
+#include <FL/names.h>
+
+// g++ -I/usr/local/include/FL -I../ -c Fl_Clock_Spinner.cxx
+
+ Fl_Clock_Spinner::Fl_Clock_Spinner(int X,int Y,int W,int H,const char*L)
+ :Fl_Group(X,Y,W,H,L),
+ _input(X,Y,W - BUTTON_ARROW_WIDTH, H),
+ _up(X + W - BUTTON_ARROW_WIDTH, Y+1, BUTTON_ARROW_WIDTH, H / 2, "@-42<"),
+ _down(X + W - BUTTON_ARROW_WIDTH, Y + H / 2, BUTTON_ARROW_WIDTH, H / 2, "@-42>"){
+  end();
+  _up.align(FL_ALIGN_TOP);
+  _down.align(FL_ALIGN_BOTTOM);
+  
+  //_input.value(12, 30);
+  
+  resize(X,Y,W,H);
+  //type(FL_READONLY_CLOCK_SPINNER);
+  
+  _up.callback((Fl_Callback *)sb_cb, this);
+  _down.callback((Fl_Callback *)sb_cb, this);
+  _input.when(FL_WHEN_ENTER_KEY | FL_WHEN_RELEASE);
+  _input.callback((Fl_Callback *)sb_cb, this);
+ }
+ 
+ 
+ 
+ void Fl_Clock_Spinner::resize(int X,int Y,int W,int H){
+  Fl_Group::resize(X,Y,W,H);
+  _input.resize(X,Y,W - BUTTON_ARROW_WIDTH, H);
+  _up.resize(X + W - BUTTON_ARROW_WIDTH, Y+1, BUTTON_ARROW_WIDTH, H / 2);
+  _down.resize(X + W - BUTTON_ARROW_WIDTH, Y + H / 2, BUTTON_ARROW_WIDTH, H / 2);
+ }
+ 
+ 
+ int Fl_Clock_Spinner::handle(int e){
+  //printf("Fl_Clock_Spinner: %s\n", fl_eventnames[e]);
+  switch(e){
+   case FL_FOCUS:{
+    if(Fl::focus() != &_input && _input.active()){ _input.take_focus(); }
+    break;
+   }
+   case FL_ENTER:
+   case FL_MOVE:
+   case FL_PUSH:{
+    int X, Y;
+    int xx, yy, ww, hh;
+    X=Fl::event_x(); Y=Fl::event_y();
+    xx = x()+_input.w();
+    yy = y();
+    ww = xx+BUTTON_ARROW_WIDTH;
+    hh = y()+h()-1;
+//   printf("X: %d; Y: %d\n", X, Y);
+//   printf("xx: %d; yy: %d\n", xx, yy);
+//   printf("ww: %d; hh: %d\n\n", ww, hh);
+  
+    if(X >= xx && Y >= yy && X < ww && Y < hh){
+     fl_cursor(FL_CURSOR_DEFAULT,FL_BLACK,FL_WHITE);
+     return Fl_Group::handle(e);
+    }
+    break;
+   }
+   default: break;
+  }
+  
+  return _input.handle(e);
+ }
+ 
+ 
+ 
+ 
+ void Fl_Clock_Spinner::sb_cb(Fl_Widget *w, Fl_Clock_Spinner *sb){
+  
+  if(w == &(sb->_up)){
+   sb->_input.incr();
+   sb->take_focus();
+   //sb->_input.take_focus();
+   //sb->_input.handle(FL_PUSH);
+  }
+  
+  else if(w == &(sb->_down)){
+   sb->_input.decr();
+   sb->take_focus();
+   //sb->_input.take_focus();
+   //sb->_input.handle(FL_PUSH);
+  }
+  
+  sb->do_callback();
+ }
+
+ 
+ 
+ void Fl_Clock_Spinner::type(int t){
+  if(t == FL_READONLY_CLOCK_SPINNER){
+   Fl_Group::type(t);
+   _up.deactivate();
+   _down.deactivate();
+   _input.type(FL_INPUT_READONLY);
+   _input.visible_focus(0);
+   redraw();
+  }
+  else {
+   if(Fl_Group::type() != FL_NORMAL_CLOCK_SPINNER){
+    Fl_Group::type(FL_NORMAL_CLOCK_SPINNER);
+    _up.activate();
+   _down.activate();
+   _input.type(FL_NORMAL_INPUT);
+   _input.visible_focus(1);
+   redraw();
+   }
+  }
+ }
+ 
+ 
+ 
+#endif
diff -U 3 -H -d -r -N -- src/Fl_Counter.cxx src/Fl_Counter.cxx
--- src/Fl_Counter.cxx	2012-07-24 10:37:22.000000000 +0600
+++ src/Fl_Counter.cxx	2013-12-21 09:51:00.343448120 +0600
@@ -20,10 +20,12 @@
 #include <FL/Fl_Counter.H>
 #include <FL/Fl_Simple_Counter.H>
 #include <FL/fl_draw.H>
+#include "fl_oxy.h"
 
 void Fl_Counter::draw() {
   int i; Fl_Boxtype boxtype[5];
   Fl_Color selcolor;
+  bool flag_oxy = (Fl::scheme() && !strcmp(Fl::scheme(), "oxy"));
 
   boxtype[0] = box();
   if (boxtype[0] == FL_UP_BOX) boxtype[0] = FL_DOWN_BOX;
@@ -36,14 +38,14 @@
 
   int xx[5], ww[5];
   if (type() == FL_NORMAL_COUNTER) {
-    int W = w()*15/100;
+    int W = flag_oxy? h() : w()*15/100;
     xx[1] = x();	 ww[1] = W;
     xx[2] = x()+1*W;     ww[2] = W;
     xx[0] = x()+2*W;     ww[0] = w()-4*W;
     xx[3] = x()+w()-2*W; ww[3] = W;
     xx[4] = x()+w()-1*W; ww[4] = W;
   } else {
-    int W = w()*20/100;
+    int W = flag_oxy? h() : w()*20/100;
     xx[1] = 0;	         ww[1] = 0;
     xx[2] = x();	 ww[2] = W;
     xx[0] = x()+W;	 ww[0] = w()-2*W;
@@ -63,18 +65,50 @@
     selcolor = labelcolor();
   else
     selcolor = fl_inactive(labelcolor());
-
+  
+  int x1, y1;
+  
   if (type() == FL_NORMAL_COUNTER) {
-    draw_box(boxtype[1], xx[1], y(), ww[1], h(), color());
-    fl_draw_symbol("@-4<<", xx[1], y(), ww[1], h(), selcolor);
+   draw_box(boxtype[1], xx[1], y(), ww[1], h(), color());
+   if(flag_oxy){
+    x1 = xx[1]+ww[1]/2-1; y1 = y()+h()/2-4;
+    // draw two left arrows
+    oxy_arrow(x1, y1, FL_ALIGN_LEFT, active_r(), color(), FL_BLACK);
+    x1+=4;
+    oxy_arrow(x1, y1, FL_ALIGN_LEFT, active_r(), color(), FL_BLACK);
+   }
+   else { fl_draw_symbol("@-4<<", xx[1], y(), ww[1], h(), selcolor); }
   }
+  
+  
   draw_box(boxtype[2], xx[2], y(), ww[2], h(), color());
-  fl_draw_symbol("@-4<",  xx[2], y(), ww[2], h(), selcolor);
+  if(flag_oxy){
+   x1 = xx[2]+ww[2]/2+2; y1 = y()+h()/2-4;
+   // draw one left arrow
+    oxy_arrow(x1, y1, FL_ALIGN_LEFT, active_r(), color(), FL_BLACK);
+  }
+  else { fl_draw_symbol("@-4<",  xx[2], y(), ww[2], h(), selcolor); }
+  
+  
   draw_box(boxtype[3], xx[3], y(), ww[3], h(), color());
-  fl_draw_symbol("@-4>",  xx[3], y(), ww[3], h(), selcolor);
+  if(flag_oxy){
+   x1 = xx[3]+ww[3]/2-2; y1 = y()+h()/2-4;
+   // draw one right arrow
+    oxy_arrow(x1, y1, FL_ALIGN_RIGHT, active_r(), color(), FL_BLACK);
+  }
+  else { fl_draw_symbol("@-4>",  xx[3], y(), ww[3], h(), selcolor); }
+  
+  
   if (type() == FL_NORMAL_COUNTER) {
-    draw_box(boxtype[4], xx[4], y(), ww[4], h(), color());
-    fl_draw_symbol("@-4>>", xx[4], y(), ww[4], h(), selcolor);
+   draw_box(boxtype[4], xx[4], y(), ww[4], h(), color());
+    if(flag_oxy){
+     x1 = xx[4]+ww[4]/2-4; y1 = y()+h()/2-4;
+     // draw two right arrows
+     oxy_arrow(x1, y1, FL_ALIGN_RIGHT, active_r(), color(), FL_BLACK);
+     x1+=4;
+     oxy_arrow(x1, y1, FL_ALIGN_RIGHT, active_r(), color(), FL_BLACK);
+   }
+   else { fl_draw_symbol("@-4>>", xx[4], y(), ww[4], h(), selcolor); }
   }
 }
 
diff -U 3 -H -d -r -N -- src/Fl_Group.cxx src/Fl_Group.cxx
--- src/Fl_Group.cxx	2012-07-24 10:37:22.000000000 +0600
+++ src/Fl_Group.cxx	2013-12-21 09:51:00.343448120 +0600
@@ -828,30 +828,30 @@
 }
 
 
-Fl_Input_Choice::Fl_Input_Choice (int X,int Y,int W,int H,const char*L) 
-: Fl_Group(X,Y,W,H,L) 
-{
-  Fl_Group::box(FL_DOWN_BOX);
-  align(FL_ALIGN_LEFT);				// default like Fl_Input
-  inp_ = new Fl_Input(inp_x(), inp_y(),
-                      inp_w(), inp_h());
-  inp_->callback(inp_cb, (void*)this);
-  inp_->box(FL_FLAT_BOX);		// cosmetic
-  inp_->when(FL_WHEN_CHANGED|FL_WHEN_NOT_CHANGED);
-  menu_ = new InputMenuButton(menu_x(), menu_y(),
-                              menu_w(), menu_h());
-  menu_->callback(menu_cb, (void*)this);
-  menu_->box(FL_FLAT_BOX);				// cosmetic
-  end();
+Fl_Input_Choice::Fl_Input_Choice(int X, int Y, int W, int H, const char *L)
+ : Fl_Menu_(X,Y,W,H,L),
+ input_(X,Y,W,H,0),
+ button_(0,0,0,0,0) {
+  box(FL_DOWN_BOX);
+  down_box(FL_UP_BOX);
+  align(FL_ALIGN_LEFT);
+  
+  input_.callback(input_cb, (void*)this);
+  input_.box(FL_FLAT_BOX);
+  input_.when(FL_WHEN_CHANGED|FL_WHEN_NOT_CHANGED);
+  
+  button_.box(FL_THIN_UP_BOX);
+  button_.down_box(FL_THIN_UP_BOX);
+  button_.align(FL_ALIGN_BOTTOM);
+  button_.callback(menu_cb, (void*)this);
 }
 
 
 Fl_Spinner::Fl_Spinner(int X, int Y, int W, int H, const char *L)
 : Fl_Group(X, Y, W, H, L),
-  input_(X, Y, W - H / 2 - 2, H),
-  up_button_(X + W - H / 2 - 2, Y, H / 2 + 2, H / 2, "@-42<"),
-  down_button_(X + W - H / 2 - 2, Y + H - H / 2,
-               H / 2 + 2, H / 2, "@-42>") 
+  input_(X, Y, W - BUTTON_ARROW_WIDTH, H),
+  up_button_(X + W - BUTTON_ARROW_WIDTH, Y, BUTTON_ARROW_WIDTH, H / 2, "@-42<"), 
+  down_button_(X + W - BUTTON_ARROW_WIDTH, Y + H / 2, BUTTON_ARROW_WIDTH, H / 2, "@-42>") 
 {
   end();
   
@@ -869,8 +869,15 @@
   input_.callback((Fl_Callback *)sb_cb, this);
   
   up_button_.callback((Fl_Callback *)sb_cb, this);
+  up_button_.align(FL_ALIGN_TOP);
+  up_button_.box(FL_THIN_UP_BOX); up_button_.down_box(FL_THIN_DOWN_BOX);
   
   down_button_.callback((Fl_Callback *)sb_cb, this);
+  down_button_.align(FL_ALIGN_BOTTOM);
+  down_button_.box(FL_THIN_UP_BOX); down_button_.down_box(FL_THIN_DOWN_BOX);
+  
+  if(Fl::scheme() && !strcmp(Fl::scheme(), "oxy")){ resize(X,Y,W,H); }
+  
 }
 
 
diff -U 3 -H -d -r -N -- src/Fl_Light_Button.cxx src/Fl_Light_Button.cxx
--- src/Fl_Light_Button.cxx	2012-12-07 22:29:49.000000000 +0600
+++ src/Fl_Light_Button.cxx	2013-12-21 09:51:00.343448120 +0600
@@ -36,7 +36,8 @@
   int W;
   int dx, dy;
 
-  W  = labelsize();
+  if(down_box() && Fl::scheme() && !strcmp(Fl::scheme(), "oxy")){ W = 15; } // for theme `oxy' - fixing size of box
+  else { W  = labelsize(); }
   dx = Fl::box_dx(box()) + 2;
   dy = (h() - W) / 2;
   // if (dy < 0) dy = 0;         // neg. offset o.k. for vertical centering
@@ -84,6 +85,8 @@
 	    fl_color(fl_color_average(FL_WHITE, FL_SELECTION_COLOR, 0.2f));
 	  } else fl_color(col);
 
+	  if(Fl::scheme() && !strcmp(Fl::scheme(), "oxy")){ tW = 5; } // for theme `oxy' - fixing size of inline circle
+
 	  switch (tW) {
 	    // Larger circles draw fine...
 	    default :
diff -U 3 -H -d -r -N -- src/Fl_Menu.cxx src/Fl_Menu.cxx
--- src/Fl_Menu.cxx	2012-12-07 22:29:49.000000000 +0600
+++ src/Fl_Menu.cxx	2013-12-21 09:51:00.344448120 +0600
@@ -28,6 +28,7 @@
 #include <FL/fl_draw.H>
 #include <stdio.h>
 #include "flstring.h"
+#include "fl_oxy.h"
 
 /** Size of the menu starting from this menu item */
 int Fl_Menu_Item::size() const {
@@ -146,6 +147,7 @@
 /** Draws the menu item in bounding box x,y,w,h, optionally selects the item. */
 void Fl_Menu_Item::draw(int x, int y, int w, int h, const Fl_Menu_* m,
 			int selected) const {
+  bool flag_oxy = (Fl::scheme() && !strcmp(Fl::scheme(), "oxy"));
   Fl_Label l;
   l.value   = text;
   l.image   = 0;
@@ -158,7 +160,7 @@
   Fl_Color color = m ? m->color() : FL_GRAY;
   if (selected) {
     Fl_Color r = m ? m->selection_color() : FL_SELECTION_COLOR;
-    Fl_Boxtype b = m && m->down_box() ? m->down_box() : FL_FLAT_BOX;
+    Fl_Boxtype b = flag_oxy?FL_UP_BOX:(m && m->down_box() ? m->down_box() : FL_FLAT_BOX);
     if (fl_contrast(r,color)!=r) { // back compatibility boxtypes
       if (selected == 2) { // menu title
 	r = color;
@@ -182,6 +184,7 @@
   if (flags & (FL_MENU_TOGGLE|FL_MENU_RADIO)) {
     int d = (h - FL_NORMAL_SIZE + 1) / 2;
     int W = h - 2 * d;
+    if(flag_oxy){ W = 15; d--; } // for theme `oxy' - fixing size of box
 
     if (flags & FL_MENU_RADIO) {
       fl_draw_box(FL_ROUND_DOWN_BOX, x+2, y+d, W, W, FL_BACKGROUND2_COLOR);
@@ -189,7 +192,9 @@
 	int tW = (W - Fl::box_dw(FL_ROUND_DOWN_BOX)) / 2 + 1;
 	if ((W - tW) & 1) tW++;	// Make sure difference is even to center
 	int td = (W - tW) / 2;
+    
         if (Fl::scheme()) {
+         if(flag_oxy){ td = Fl::box_dx(FL_ROUND_DOWN_BOX) + 1; }
 	  if (!strcmp(Fl::scheme(), "gtk+")) {
 	    fl_color(FL_SELECTION_COLOR);
 	    tW --;
@@ -198,6 +203,8 @@
 	  } else fl_color(labelcolor_);
 	} else fl_color(labelcolor_);
 
+	if(flag_oxy){ tW = 5; } // for theme `oxy' - fixing size of inline circle
+
 	switch (tW) {
 	  // Larger circles draw fine...
 	  default :
@@ -277,6 +284,7 @@
 
   Fl::screen_work_area(scr_x, scr_y, scr_w, scr_h);
   if (!right_edge || right_edge > scr_x+scr_w) right_edge = scr_x+scr_w;
+  
 
   end();
   set_modal();
@@ -427,6 +435,8 @@
 void menuwindow::drawentry(const Fl_Menu_Item* m, int n, int eraseit) {
   if (!m) return; // this happens if -1 is selected item and redrawn
 
+  bool flag_oxy = (Fl::scheme() && !strcmp(Fl::scheme(), "oxy"));
+
   int BW = Fl::box_dx(box());
   int xx = BW;
   int W = w();
@@ -436,7 +446,7 @@
 
   if (eraseit && n != selected) {
     fl_push_clip(xx+1, yy-(LEADING-2)/2, ww-2, hh+(LEADING-2));
-    draw_box(box(), 0, 0, w(), h(), button ? button->color() : color());
+    draw_box(box(), 0, 0, w(), h(), button ? button->color() : color()); // NOTE : bg-box for item
     fl_pop_clip();
   }
 
@@ -444,10 +454,16 @@
 
   // the shortcuts and arrows assume fl_color() was left set by draw():
   if (m->submenu()) {
-    int sz = (hh-7)&-2;
-    int y1 = yy+(hh-sz)/2;
-    int x1 = xx+ww-sz-3;
-    fl_polygon(x1+2, y1, x1+2, y1+sz, x1+sz/2+2, y1+sz/2);
+   int sz = (hh-7)&-2;
+   int y1 = yy+(hh-sz)/2;
+   int x1 = xx+ww-sz-3;
+   
+   // draw arrows for the OXY theme
+   if (flag_oxy) {
+    x1+=(sz/2-BW*2-1);
+    y1=yy+hh/2-4; // 4 is half of arrow height
+    oxy_arrow(x1, y1, FL_ALIGN_RIGHT, active_r(), color(), (n==selected)?selection_color():FL_BLACK);
+   } else { fl_polygon(x1+2, y1, x1+2, y1+sz, x1+sz/2+2, y1+sz/2); }
   } else if (m->shortcut_) {
     Fl_Font f = m->labelsize_ || m->labelfont_ ? (Fl_Font)m->labelfont_ :
                     button ? button->textfont() : FL_HELVETICA;
diff -U 3 -H -d -r -N -- src/Fl_Menu_Button.cxx src/Fl_Menu_Button.cxx
--- src/Fl_Menu_Button.cxx	2012-08-17 03:35:14.000000000 +0600
+++ src/Fl_Menu_Button.cxx	2013-12-21 09:51:00.344448120 +0600
@@ -19,7 +19,7 @@
 #include <FL/Fl.H>
 #include <FL/Fl_Menu_Button.H>
 #include <FL/fl_draw.H>
-
+#include "fl_oxy.h"
 
 static Fl_Menu_Button	*pressed_menu_button_ = 0;
 
@@ -33,10 +33,20 @@
   draw_label(x()+Fl::box_dx(box()), y(), X-x()+2, h());
   if (Fl::focus() == this) draw_focus();
   // ** if (box() == FL_FLAT_BOX) return; // for XForms compatibility
-  fl_color(active_r() ? FL_DARK3 : fl_inactive(FL_DARK3));
-  fl_line(X+H/2, Y+H, X, Y, X+H, Y);
-  fl_color(active_r() ? FL_LIGHT3 : fl_inactive(FL_LIGHT3));
-  fl_line(X+H, Y, X+H/2, Y+H);
+  bool flag_oxy = (Fl::scheme() && !strcmp(Fl::scheme(), "oxy"));
+  
+  if(flag_oxy){
+    int x1 = X;
+    int y1 = Y+3;
+    oxy_arrow(x1, y1, FL_ALIGN_BOTTOM, active_r(), color(), FL_BLACK);
+  }
+  
+  else {
+   fl_color(active_r() ? FL_DARK3 : fl_inactive(FL_DARK3));
+   fl_line(X+H/2, Y+H, X, Y, X+H, Y);
+   fl_color(active_r() ? FL_LIGHT3 : fl_inactive(FL_LIGHT3));
+   fl_line(X+H, Y, X+H/2, Y+H);
+  }
 }
 
 
diff -U 3 -H -d -r -N -- src/Fl_Scrollbar.cxx src/Fl_Scrollbar.cxx
--- src/Fl_Scrollbar.cxx	2011-07-19 10:49:30.000000000 +0600
+++ src/Fl_Scrollbar.cxx	2013-12-21 09:51:00.345448120 +0600
@@ -22,6 +22,7 @@
 #include <FL/fl_draw.H>
 #include <math.h>
 #include "flstring.h"
+#include "fl_oxy.h"
 
 #define INITIALREPEAT .5
 #define REPEAT .05
@@ -222,10 +223,16 @@
 	fl_polygon(x1, yy1+w1, x1+w1, yy1+2*w1, x1+w1-1, yy1+w1, x1+w1, yy1);
 	x1 += (W-H);
 	fl_polygon(x1, yy1, x1+1, yy1+w1, x1, yy1+2*w1, x1+w1, yy1+w1);
+      } else if(Fl::scheme_ && !strcmp(Fl::scheme_, "oxy")){
+       x1 = X+H/2+2;
+       int y1 = Y+H/2-3-2;
+       oxy_arrow(x1, y1, FL_ALIGN_LEFT, active_r(), color(), FL_BLACK); /// LEFT ARROW
+       x1 += (W-H)-4;
+       oxy_arrow(x1, y1, FL_ALIGN_RIGHT, active_r(), color(), FL_BLACK); /// RIGHT ARROW
       } else {
-	fl_polygon(x1, yy1+w1, x1+w1, yy1+2*w1, x1+w1, yy1);
-	x1 += (W-H);
-	fl_polygon(x1, yy1, x1, yy1+2*w1, x1+w1, yy1+w1);
+    fl_polygon(x1, yy1+w1, x1+w1, yy1+2*w1, x1+w1, yy1);
+    x1 += (W-H);
+    fl_polygon(x1, yy1, x1, yy1+2*w1, x1+w1, yy1+w1);
       }
     }
   } else { // vertical
@@ -248,6 +255,12 @@
 	yy1 += H-W;
 	fl_polygon(x1, yy1, x1+w1, yy1+1, x1+w1, yy1+w1);
 	fl_polygon(x1+w1, yy1+1, x1+2*w1, yy1, x1+w1, yy1+w1);
+      } else if(Fl::scheme_ && !strcmp(Fl::scheme_, "oxy")){
+       x1 = X+W/2-4;
+       int y1 = Y+W/2+1;
+       oxy_arrow(x1, y1, FL_ALIGN_TOP, active_r(), color(), FL_BLACK); /// TOP ARROW
+      y1 += H-W-3;
+      oxy_arrow(x1, y1, FL_ALIGN_BOTTOM, active_r(), color(), FL_BLACK); /// BOTTOM ARROW
       } else {
 	fl_polygon(x1, yy1+w1, x1+2*w1, yy1+w1, x1+w1, yy1);
 	yy1 += H-W;
